/*******************************************************************/
/*                                                                 */
/*                      ADOBE CONFIDENTIAL                         */
/*                   _ _ _ _ _ _ _ _ _ _ _ _ _                     */
/*                                                                 */
/* Copyright 2007 Adobe Systems Incorporated                       */
/* All Rights Reserved.                                            */
/*                                                                 */
/* NOTICE:  All information contained herein is, and remains the   */
/* property of Adobe Systems Incorporated and its suppliers, if    */
/* any.  The intellectual and technical concepts contained         */
/* herein are proprietary to Adobe Systems Incorporated and its    */
/* suppliers and may be covered by U.S. and Foreign Patents,       */
/* patents in process, and are protected by trade secret or        */
/* copyright law.  Dissemination of this information or            */
/* reproduction of this material is strictly forbidden unless      */
/* prior written permission is obtained from Adobe Systems         */
/* Incorporated.                                                   */
/*                                                                 */
/*******************************************************************/

#include "Supervisor.h"
	
typedef struct {
	unsigned long	index;
	char			str[256];
} TableString;



TableString		g_strs[StrID_NUMTYPES] = {
	StrID_NONE,				"",
	StrID_LayerName,		"Some Layer",
	StrID_ModePopName,		"Mode",
	StrID_ModePopChoices,	"Easy|"
							"Hard", 
	StrID_FlavorName,		"Flavor",		
	StrID_FlavorChoices,	"Chocolate|"
							"(-|"
							"Strawberry|"
							"(-|"
							"Sherbet",
	StrID_FlavorChoicesChanged,
							"Chocolate|"
							"(-|"
							"Strawberry|"
							"(-|"
							"And more!",

	StrID_ColorHard,		"Color",
	StrID_ColorEasy,		"(Ignored while Easy)",
	StrID_FlavorHard,		"Disabled in Hard mode",

	StrID_SliderHard,		"Whoa", 
	StrID_SliderEasy,		"Leverage", 

	StrID_Check1Hard,		"Mojo", 
	StrID_Check1Easy,		"Default sub-title", 
	StrID_Check1Changed,	"Changed by ChangedParam!", 

	StrID_Check2Hard,		"", 
	StrID_Check2Easy,		"Takeaway", 
	

	StrID_Err_LoadSuite,	"Couldn't acquire Suite.", 
	StrID_Err_FreeSuite,	"Couldn't free Suite.",
	StrID_TopicName,		"Details", 
	StrID_TopicNameDisabled,"(Disabled while Easy)",
	StrID_FlavorDisabled,	"(Flavor Disabled in Easy Mode.)",
	StrID_Name,				"Supervisor",
	StrID_Description,		"Demonstrates parameter supervision. Also, dig the whizzy seperators in the 'Flavor' pop-up!",
	StrID_ColorError,		"Color ignored in Easy mode.",
	StrID_GeneralError,		"Error handling Changed Param."
};

char	*GetStringPtr(int strNum)
{
	return g_strs[strNum].str;
}
